﻿Namespace Data

    Public Class DbInitializer

        Public Shared Sub Initialize(ByVal context As SchoolContext)
            If context.Students.Any() Then
                Return
            End If

            Dim students = New Models.Student() {
                New Models.Student With {.FirstMidName = "Carson", .LastName = "Alexander", .EnrollmentDate = DateTime.Parse("2010-09-01")},
                New Models.Student With {.FirstMidName = "Meredith", .LastName = "Alonso", .EnrollmentDate = DateTime.Parse("2012-09-01")},
                New Models.Student With {.FirstMidName = "Arturo", .LastName = "Anand", .EnrollmentDate = DateTime.Parse("2013-09-01")},
                New Models.Student With {.FirstMidName = "Gytis", .LastName = "Barzdukas", .EnrollmentDate = DateTime.Parse("2012-09-01")},
                New Models.Student With {.FirstMidName = "Yan", .LastName = "Li", .EnrollmentDate = DateTime.Parse("2012-09-01")},
                New Models.Student With {.FirstMidName = "Peggy", .LastName = "Justice", .EnrollmentDate = DateTime.Parse("2011-09-01")},
                New Models.Student With {.FirstMidName = "Laura", .LastName = "Norman", .EnrollmentDate = DateTime.Parse("2013-09-01")},
                New Models.Student With {.FirstMidName = "Nino", .LastName = "Olivetto", .EnrollmentDate = DateTime.Parse("2005-09-01")}}
            For Each s As Models.Student In students
                context.Students.Add(s)
            Next
            context.SaveChanges()

            Dim instructors = New Models.Instructor() {
                New Models.Instructor With {.FirstMidName = "Kim", .LastName = "Abercrombie", .HireDate = DateTime.Parse("1995-03-11")},
                New Models.Instructor With {.FirstMidName = "Fadi", .LastName = "Fakhouri", .HireDate = DateTime.Parse("2002-07-06")},
                New Models.Instructor With {.FirstMidName = "Roger", .LastName = "Harui", .HireDate = DateTime.Parse("1998-07-01")},
                New Models.Instructor With {.FirstMidName = "Candace", .LastName = "Kapoor", .HireDate = DateTime.Parse("2001-01-15")},
                New Models.Instructor With {.FirstMidName = "Roger", .LastName = "Zheng", .HireDate = DateTime.Parse("2004-02-12")}}
            For Each i As Models.Instructor In instructors
                context.Instructors.Add(i)
            Next
            context.SaveChanges()

            Dim departments = New Models.Department() {
                New Models.Department With {.Name = "English", .Budget = 350000, .StartDate = DateTime.Parse("2007-09-01"), .InstructorID = instructors.Single(Function(i) i.LastName = "Abercrombie").ID},
                New Models.Department With {.Name = "Mathematics", .Budget = 100000, .StartDate = DateTime.Parse("2007-09-01"), .InstructorID = instructors.Single(Function(i) i.LastName = "Fakhouri").ID},
                New Models.Department With {.Name = "Engineering", .Budget = 350000, .StartDate = DateTime.Parse("2007-09-01"), .InstructorID = instructors.Single(Function(i) i.LastName = "Harui").ID},
                New Models.Department With {.Name = "Economics", .Budget = 100000, .StartDate = DateTime.Parse("2007-09-01"), .InstructorID = instructors.Single(Function(i) i.LastName = "Kapoor").ID}}
            For Each d As Models.Department In departments
                context.Departments.Add(d)
            Next
            context.SaveChanges()

            Dim courses = New Models.Course() {
                New Models.Course With {.CourseID = 1050, .Title = "Chemistry", .Credits = 3, .DepartmentID = departments.Single(Function(s) s.Name = "Engineering").DepartmentID},
                New Models.Course With {.CourseID = 4022, .Title = "Microeconomics", .Credits = 3, .DepartmentID = departments.Single(Function(s) s.Name = "Economics").DepartmentID},
                New Models.Course With {.CourseID = 4041, .Title = "Macroeconomics", .Credits = 3, .DepartmentID = departments.Single(Function(s) s.Name = "Economics").DepartmentID},
                New Models.Course With {.CourseID = 1045, .Title = "Calculus", .Credits = 4, .DepartmentID = departments.Single(Function(s) s.Name = "Mathematics").DepartmentID},
                New Models.Course With {.CourseID = 3141, .Title = "Trigonometry", .Credits = 4, .DepartmentID = departments.Single(Function(s) s.Name = "Mathematics").DepartmentID},
                New Models.Course With {.CourseID = 2021, .Title = "Composition", .Credits = 3, .DepartmentID = departments.Single(Function(s) s.Name = "English").DepartmentID},
                New Models.Course With {.CourseID = 2042, .Title = "Literature", .Credits = 4, .DepartmentID = departments.Single(Function(s) s.Name = "English").DepartmentID}}
            For Each c As Models.Course In courses
                context.Courses.Add(c)
            Next
            context.SaveChanges()

            Dim officeAssignments = New Models.OfficeAssignment() {
                New Models.OfficeAssignment With {.InstructorID = instructors.Single(Function(i) i.LastName = "Fakhouri").ID, .Location = "Smith 17"},
                New Models.OfficeAssignment With {.InstructorID = instructors.Single(Function(i) i.LastName = "Harui").ID, .Location = "Gowan 27"},
                New Models.OfficeAssignment With {.InstructorID = instructors.Single(Function(i) i.LastName = "Kapoor").ID, .Location = "Thompson 304"}}
            For Each o As Models.OfficeAssignment In officeAssignments
                context.OfficeAssignments.Add(o)
            Next
            context.SaveChanges()

            Dim courseInstructors = New Models.CourseAssignment() {
                New Models.CourseAssignment With {.CourseID = courses.Single(Function(c) c.Title = "Chemistry").CourseID, .InstructorID = instructors.Single(Function(i) i.LastName = "Kapoor").ID},
                New Models.CourseAssignment With {.CourseID = courses.Single(Function(c) c.Title = "Chemistry").CourseID, .InstructorID = instructors.Single(Function(i) i.LastName = "Harui").ID},
                New Models.CourseAssignment With {.CourseID = courses.Single(Function(c) c.Title = "Microeconomics").CourseID, .InstructorID = instructors.Single(Function(i) i.LastName = "Zheng").ID},
                New Models.CourseAssignment With {.CourseID = courses.Single(Function(c) c.Title = "Macroeconomics").CourseID, .InstructorID = instructors.Single(Function(i) i.LastName = "Zheng").ID},
                New Models.CourseAssignment With {.CourseID = courses.Single(Function(c) c.Title = "Calculus").CourseID, .InstructorID = instructors.Single(Function(i) i.LastName = "Fakhouri").ID},
                New Models.CourseAssignment With {.CourseID = courses.Single(Function(c) c.Title = "Trigonometry").CourseID, .InstructorID = instructors.Single(Function(i) i.LastName = "Harui").ID},
                New Models.CourseAssignment With {.CourseID = courses.Single(Function(c) c.Title = "Composition").CourseID, .InstructorID = instructors.Single(Function(i) i.LastName = "Abercrombie").ID},
                New Models.CourseAssignment With {.CourseID = courses.Single(Function(c) c.Title = "Literature").CourseID, .InstructorID = instructors.Single(Function(i) i.LastName = "Abercrombie").ID}}
            For Each ci As Models.CourseAssignment In courseInstructors
                context.CourseAssignments.Add(ci)
            Next
            context.SaveChanges()

            Dim enrollments = New Models.Enrollment() {
                New Models.Enrollment With {.StudentID = students.Single(Function(s) s.LastName = "Alexander").ID, .CourseID = courses.Single(Function(c) c.Title = "Chemistry").CourseID, .Grade = Models.Grade.A},
                New Models.Enrollment With {.StudentID = students.Single(Function(s) s.LastName = "Alexander").ID, .CourseID = courses.Single(Function(c) c.Title = "Microeconomics").CourseID, .Grade = Models.Grade.C},
                New Models.Enrollment With {.StudentID = students.Single(Function(s) s.LastName = "Alexander").ID, .CourseID = courses.Single(Function(c) c.Title = "Macroeconomics").CourseID, .Grade = Models.Grade.B},
                New Models.Enrollment With {.StudentID = students.Single(Function(s) s.LastName = "Alonso").ID, .CourseID = courses.Single(Function(c) c.Title = "Calculus").CourseID, .Grade = Models.Grade.B},
                New Models.Enrollment With {.StudentID = students.Single(Function(s) s.LastName = "Alonso").ID, .CourseID = courses.Single(Function(c) c.Title = "Trigonometry").CourseID, .Grade = Models.Grade.B},
                New Models.Enrollment With {.StudentID = students.Single(Function(s) s.LastName = "Alonso").ID, .CourseID = courses.Single(Function(c) c.Title = "Composition").CourseID, .Grade = Models.Grade.B},
                New Models.Enrollment With {.StudentID = students.Single(Function(s) s.LastName = "Anand").ID, .CourseID = courses.Single(Function(c) c.Title = "Chemistry").CourseID},
                New Models.Enrollment With {.StudentID = students.Single(Function(s) s.LastName = "Anand").ID, .CourseID = courses.Single(Function(c) c.Title = "Microeconomics").CourseID, .Grade = Models.Grade.B},
                New Models.Enrollment With {.StudentID = students.Single(Function(s) s.LastName = "Barzdukas").ID, .CourseID = courses.Single(Function(c) c.Title = "Chemistry").CourseID, .Grade = Models.Grade.B},
                New Models.Enrollment With {.StudentID = students.Single(Function(s) s.LastName = "Li").ID, .CourseID = courses.Single(Function(c) c.Title = "Composition").CourseID, .Grade = Models.Grade.B},
                New Models.Enrollment With {.StudentID = students.Single(Function(s) s.LastName = "Justice").ID, .CourseID = courses.Single(Function(c) c.Title = "Literature").CourseID, .Grade = Models.Grade.B}}
            For Each e As Models.Enrollment In enrollments
                Dim enrollmentInDataBase = context.Enrollments.SingleOrDefault(Function(s) s.Student.ID = e.StudentID AndAlso s.Course.CourseID = e.CourseID)
                If enrollmentInDataBase Is Nothing Then
                    context.Enrollments.Add(e)
                End If
            Next
            context.SaveChanges()

        End Sub
    End Class
End Namespace
