Imports System
Imports System.Data.Entity.Migrations
Imports Microsoft.VisualBasic

Namespace Migrations
    Public Partial Class InitialCreate
        Inherits DbMigration
    
        Public Overrides Sub Up()
            CreateTable(
                "dbo.CourseAssignment",
                Function(c) New With
                    {
                        .CourseID = c.Int(nullable := False),
                        .InstructorID = c.Int(nullable := False)
                    }) _
                .PrimaryKey(Function(t) New With { t.CourseID, t.InstructorID }) _
                .ForeignKey("dbo.Course", Function(t) t.CourseID, cascadeDelete := True) _
                .ForeignKey("dbo.Instructor", Function(t) t.InstructorID) _
                .Index(Function(t) t.CourseID) _
                .Index(Function(t) t.InstructorID)
            
            CreateTable(
                "dbo.Course",
                Function(c) New With
                    {
                        .CourseID = c.Int(nullable := False),
                        .Title = c.String(maxLength := 50),
                        .Credits = c.Int(nullable := False),
                        .DepartmentID = c.Int(nullable := False)
                    }) _
                .PrimaryKey(Function(t) t.CourseID) _
                .ForeignKey("dbo.Department", Function(t) t.DepartmentID, cascadeDelete := True) _
                .Index(Function(t) t.DepartmentID)
            
            CreateTable(
                "dbo.Department",
                Function(c) New With
                    {
                        .DepartmentID = c.Int(nullable := False, identity := True),
                        .Name = c.String(maxLength := 50),
                        .Budget = c.Decimal(nullable := False, storeType := "money"),
                        .StartDate = c.DateTime(nullable := False),
                        .InstructorID = c.Int(),
                        .RowVersion = c.Binary(nullable := False, fixedLength := true, timestamp := True, storeType := "rowversion")
                    }) _
                .PrimaryKey(Function(t) t.DepartmentID) _
                .ForeignKey("dbo.Instructor", Function(t) t.InstructorID) _
                .Index(Function(t) t.InstructorID)
            
            CreateTable(
                "dbo.Person",
                Function(c) New With
                    {
                        .ID = c.Int(nullable := False, identity := True),
                        .LastName = c.String(nullable := False, maxLength := 50),
                        .FirstName = c.String(nullable := False, maxLength := 50)
                    }) _
                .PrimaryKey(Function(t) t.ID)
            
            CreateTable(
                "dbo.OfficeAssignment",
                Function(c) New With
                    {
                        .InstructorID = c.Int(nullable := False, identity := True),
                        .Location = c.String(maxLength := 50),
                        .Instructor_ID = c.Int()
                    }) _
                .PrimaryKey(Function(t) t.InstructorID) _
                .ForeignKey("dbo.Instructor", Function(t) t.Instructor_ID) _
                .Index(Function(t) t.Instructor_ID)
            
            CreateTable(
                "dbo.Enrollment",
                Function(c) New With
                    {
                        .EnrollmentID = c.Int(nullable := False, identity := True),
                        .CourseID = c.Int(nullable := False),
                        .StudentID = c.Int(nullable := False),
                        .Grade = c.Int()
                    }) _
                .PrimaryKey(Function(t) t.EnrollmentID) _
                .ForeignKey("dbo.Course", Function(t) t.CourseID, cascadeDelete := True) _
                .ForeignKey("dbo.Student", Function(t) t.StudentID) _
                .Index(Function(t) t.CourseID) _
                .Index(Function(t) t.StudentID)
            
            CreateTable(
                "dbo.Instructor",
                Function(c) New With
                    {
                        .ID = c.Int(nullable := False),
                        .HireDate = c.DateTime(nullable := False)
                    }) _
                .PrimaryKey(Function(t) t.ID) _
                .ForeignKey("dbo.Person", Function(t) t.ID) _
                .Index(Function(t) t.ID)
            
            CreateTable(
                "dbo.Student",
                Function(c) New With
                    {
                        .ID = c.Int(nullable := False),
                        .EnrollmentDate = c.DateTime(nullable := False)
                    }) _
                .PrimaryKey(Function(t) t.ID) _
                .ForeignKey("dbo.Person", Function(t) t.ID) _
                .Index(Function(t) t.ID)
            
        End Sub
        
        Public Overrides Sub Down()
            DropForeignKey("dbo.Student", "ID", "dbo.Person")
            DropForeignKey("dbo.Instructor", "ID", "dbo.Person")
            DropForeignKey("dbo.Enrollment", "StudentID", "dbo.Student")
            DropForeignKey("dbo.Enrollment", "CourseID", "dbo.Course")
            DropForeignKey("dbo.Course", "DepartmentID", "dbo.Department")
            DropForeignKey("dbo.Department", "InstructorID", "dbo.Instructor")
            DropForeignKey("dbo.OfficeAssignment", "Instructor_ID", "dbo.Instructor")
            DropForeignKey("dbo.CourseAssignment", "InstructorID", "dbo.Instructor")
            DropForeignKey("dbo.CourseAssignment", "CourseID", "dbo.Course")
            DropIndex("dbo.Student", New String() { "ID" })
            DropIndex("dbo.Instructor", New String() { "ID" })
            DropIndex("dbo.Enrollment", New String() { "StudentID" })
            DropIndex("dbo.Enrollment", New String() { "CourseID" })
            DropIndex("dbo.OfficeAssignment", New String() { "Instructor_ID" })
            DropIndex("dbo.Department", New String() { "InstructorID" })
            DropIndex("dbo.Course", New String() { "DepartmentID" })
            DropIndex("dbo.CourseAssignment", New String() { "InstructorID" })
            DropIndex("dbo.CourseAssignment", New String() { "CourseID" })
            DropTable("dbo.Student")
            DropTable("dbo.Instructor")
            DropTable("dbo.Enrollment")
            DropTable("dbo.OfficeAssignment")
            DropTable("dbo.Person")
            DropTable("dbo.Department")
            DropTable("dbo.Course")
            DropTable("dbo.CourseAssignment")
        End Sub
    End Class
End Namespace
