﻿#Const Type = "Final"
'#Const Type = "Intro"

#If Type = "Intro" Then
#Region "snippet_Intro"

Imports System.Collections.Generic
Imports System.ComponentModel.DataAnnotations
Imports System.ComponentModel.DataAnnotations.Schema

Namespace Models

    Public Class Course

        <DatabaseGenerated(DatabaseGeneratedOption.None)>
        Public Property CourseID As Integer

        Public Property Title As String

        Public Property Credits As Integer

        Public Property Enrollments As ICollection(Of Enrollment)
    End Class

End Namespace
#End Region

#ElseIf Type = "Final" Then

#Region "snippet_Final"

Imports System.Collections.Generic
Imports System.ComponentModel.DataAnnotations
Imports System.ComponentModel.DataAnnotations.Schema

Namespace Models

    Public Class Course

        <DatabaseGenerated(DatabaseGeneratedOption.None)>
        <Display(Name:="Number")>
        Public Property CourseID As Integer

        <StringLength(50, MinimumLength:=3)>
        Public Property Title As String

        <Range(0, 5)>
        Public Property Credits As Integer

        Public Property DepartmentID As Integer

        Public Property Department As Department

        Public Property Enrollments As ICollection(Of Enrollment)

        Public Property CourseAssignments As ICollection(Of CourseAssignment)
    End Class
End Namespace

#End Region

#End If