﻿'#Const Type = "AfterInheritance"
#Const Type = "BeforeInheritance"

#If Type = "BeforeInheritance" Then
#Region "snippet_BeforeInheritance"

Imports System
Imports System.Collections.Generic
Imports System.ComponentModel.DataAnnotations
Imports System.ComponentModel.DataAnnotations.Schema

Namespace Models
    Public Class Instructor

        Public Property ID As Integer

        <Required>
        <Display(Name:="Last Name")>
        <StringLength(50)>
        Public Property LastName As String

        <Required>
        <Column("FirstName")>
        <Display(Name:="First Name")>
        <StringLength(50)>
        Public Property FirstMidName As String

        <DataType(DataType.Date)>
        <DisplayFormat(DataFormatString:="{0:yyyy-MM-dd}", ApplyFormatInEditMode:=True)>
        <Display(Name:="Hire Date")>
        Public Property HireDate As DateTime

        <Display(Name:="Full Name")>
        Public ReadOnly Property FullName As String
            Get
                Return LastName & ", " & FirstMidName
            End Get
        End Property

        Public Property CourseAssignments As ICollection(Of CourseAssignment)

        Public Property OfficeAssignment As OfficeAssignment
    End Class

End Namespace

#End Region
#ElseIf Type = "AfterInheritance" Then

#Region "snippet_AfterInheritance"
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel.DataAnnotations
Imports System.ComponentModel.DataAnnotations.Schema

Namespace Models

    Public Class Instructor
        Inherits Person

        <DataType(DataType.Date)>
        <DisplayFormat(DataFormatString:="{0:yyyy-MM-dd}", ApplyFormatInEditMode:=True)>
        <Display(Name:="Hire Date")>
        Public Property HireDate As DateTime

        Public Property CourseAssignments As ICollection(Of CourseAssignment)

        Public Property OfficeAssignment As ICollection(Of OfficeAssignment)
    End Class
End Namespace
#End Region

#End If